function sl_customization(cm)
    cm.addCustomMenuFcn('Simulink:ContextMenu', @registerLineTraceMenu);
end

%%
function schemaFcns = registerLineTraceMenu()
    schemaFcns = { @registerLineTraceForwardMenu, @registerLineTraceBackwardMenu };
end

%% ej[̓o^֐
function schema = registerLineTraceForwardMenu( info )
    schema = sl_action_schema;

    schema.label = sprintf( 'Line̐ڑg[X');
    schema.callback = @lineTraceForward;

    % IĂ̂MłȂ΁Aj[O[AEg
    if lineSelected( info.uiObject.Handle )
        schema.state = 'Enabled';
    else
        schema.state = 'Disabled';
    end
end

function schema = registerLineTraceBackwardMenu( info )
    schema = sl_action_schema;

    schema.label = sprintf( 'Line̐ڑg[X');
    schema.callback = @lineTraceBackward;

    % IĂ̂MłȂ΁Aj[O[AEg
    if lineSelected( info.uiObject.Handle )
        schema.state = 'Enabled';
    else
        schema.state = 'Disabled';
    end
end

%% IĂ̂AMۂ𔻒肷
function result = lineSelected( parent )
    result = false;     % IĂ̂AMH

    % IĂ̂AMۂ𔻒肷
    %   ܂AIԂɂIuWFNgׂČB
    %   ̏ŁÂPłMiTypelinejłΌʂtrueƂ
    selected = find_system( parent, ...
                        'findall','on','LookUnderMasks','off', ...
                        'Selected', 'on');
                    
    selectedType = cellstr( get_param( selected, 'Type' ) );   % IԂɂ̂Type
    for i = 1:length( selectedType )
        if strcmp( selectedType{ i }, 'line' )
            % PłTypelineł
            % MIĂƔ肷
            result = true;
        end
    end
    
end

%% M̐ڑnCCg
function lineTraceForward(callbackInfo)

    % Iꂽ̎擾
    tmp = find_system(callbackInfo.uiObject.Handle, ...
                        'findall','on','LookUnderMasks','off', ...
                        'Type', 'Line', 'Selected', 'on');

    % IꂽAnCCgubN̈ꗗ쐬
    hilite_blocks = []; % nCCgubÑnhXg
    for i = 1 : length(tmp)
        % M tmp(i) ̐ڑ|[ĝALȕ
        port_handle = get_param(tmp(i), 'DstPortHandle');
        port_handle = port_handle( port_handle ~= -1 );     % |[g(-1)O

        % ڑ|[gAnCCgubN̈ꗗ쐬
        %   ڑ悪TuVXe̓̓|[g̏ꍇ  TuVXe̊YInportnCCg
        %   ڑ悪o̓|[g̏ꍇ  TuVXeO̊YMnCCg
        %   ڑ悪ȊȌꍇ  ڑ̃ubNnCCg
        for j = 1 : length(port_handle)
            % nCCgubN擾
            port_parent = get_param(port_handle(j), 'Parent');  % |[ĝubNi邢̓TuVXej
            if strcmp(get_param(port_parent, 'Type'), 'block')
                % ΏۂubN̏ꍇ

                if strcmp(get_param(port_parent, 'BlockType'), 'SubSystem')
                    % ΏۂTuVXȅꍇ
                    port = find_system(port_parent, 'Port', int2str(get_param(port_handle(j), 'PortNumber')), 'BlockType', 'Inport');
                    hilite_blocks( end + 1 ) = get_param( cell2mat( port ), 'Handle' ); %#ok<AGROW>
                else
                    % ΏۂTuVXełȂAPȂubN̏ꍇ

                    if strcmp( get_param( port_parent, 'BlockType' ), 'Outport' )
                        % ꂪOutport̏ꍇ
                        parent_system = get_param( port_parent, 'Parent' ); % eTuVXe
                        if strcmp( get_param( parent_system, 'type' ), 'block_diagram' )
                            % ŏʂOutportł΁AnCCg
                            hilite_blocks( end + 1 ) = get_param( port_parent, 'Handle' ); %#ok<AGROW>
                        else
                            % ŏʂOutportłȂ΁A
                            % ɂȂM擾
                            portNumber = str2num( get_param( port_parent, 'Port' ) ); %#ok<ST2NM>
                            portHandles = get_param( get_param( port_parent, 'Parent' ), 'PortHandles' );   % eTuVXẽ|[gnh
                            outport = portHandles.Outport( portNumber );      % Yo̓|[g
                            hilite_blocks( end + 1 ) = get_param( outport, 'Line' ); %#ok<AGROW>
                        end
                    else
                        % Outportł͂Ȃꍇ
                        % ̃ubNgnCCgΏۂƂ
                        hilite_blocks( end + 1 ) = get_param( port_parent, 'Handle' ); %#ok<AGROW>
                    end
                end
            end
        end
    end

    % eubNnCCg
    hiliteEachBlocks( hilite_blocks );

end

%% M̐ڑnCCg
function lineTraceBackward(callbackInfo)

    % Iꂽ̎擾
    tmp = find_system(callbackInfo.uiObject.Handle, ...
                        'findall','on','LookUnderMasks','off', ...
                        'Type', 'Line', 'Selected', 'on');

    % IꂽAnCCgubN̈ꗗ쐬
    hilite_blocks = []; % nCCgubÑnhXg
    for i = 1 : length(tmp)
        % M tmp(i) ̐ڑ|[ĝALȕ
        port_handle = get_param(tmp(i), 'SrcPortHandle');
        port_handle = port_handle( port_handle ~= -1 );     % |[g(-1)O

        % ڑ|[gAnCCgubN̈ꗗ쐬
        %   ڑTuVXȅo̓|[g̏ꍇ  TuVXe̊YOutportnCCg
        %   ڑ̓|[g̏ꍇ  TuVXeO̊YMnCCg
        %   ڑȊȌꍇ  ڑ̃ubNnCCg
        for j = 1 : length(port_handle)
            % nCCgubN擾
            port_parent = get_param(port_handle(j), 'Parent');  % |[ĝubNi邢̓TuVXej
            if strcmp(get_param(port_parent, 'Type'), 'block')
                % ΏۂubN̏ꍇ

                if strcmp(get_param(port_parent, 'BlockType'), 'SubSystem')
                    % ΏۂTuVXȅꍇ
                    port = find_system(port_parent, 'Port', int2str(get_param(port_handle(j), 'PortNumber')), 'BlockType', 'Outport');
                    hilite_blocks( end + 1 ) = get_param( cell2mat( port ), 'Handle' ); %#ok<AGROW>
                else
                    % ΏۂTuVXełȂAPȂubN̏ꍇ

                    if strcmp( get_param( port_parent, 'BlockType' ), 'Inport' )
                        % ꂪInport̏ꍇ
                        parent_system = get_param( port_parent, 'Parent' ); % eTuVXe
                        if strcmp( get_param( parent_system, 'type' ), 'block_diagram' )
                            % ŏʂInportł΁AnCCg
                            hilite_blocks( end + 1 ) = get_param( port_parent, 'Handle' ); %#ok<AGROW>
                        else
                            % ŏʂInportłȂ΁A
                            % ɂȂM擾
                            portNumber = str2num( get_param( port_parent, 'Port' ) ); %#ok<ST2NM>
                            portHandles = get_param( get_param( port_parent, 'Parent' ), 'PortHandles' );   % eTuVXẽ|[gnh
                            inport = portHandles.Inport( portNumber );      % Yo̓|[g
                            hilite_blocks( end + 1 ) = get_param( inport, 'Line' ); %#ok<AGROW>
                        end
                    else
                        % Inportł͂Ȃꍇ
                        % ̃ubNgnCCgΏۂƂ
                        hilite_blocks( end + 1 ) = get_param( port_parent, 'Handle' ); %#ok<AGROW>
                    end
                end
            end
        end
    end

    % eubNnCCg
    hiliteEachBlocks( hilite_blocks );
end

%% w肳ꂽubNPPnCCg܂
function hiliteEachBlocks( hiliteItems )
    % hilite_blocksŎw肳ꂽ̂nCCg
    hiliteItems = unique( hiliteItems );                % d菜
    hiliteItems = hiliteItems( hiliteItems ~= -1 );   % nh(-1)O
    for i = 1:length( hiliteItems )
        % ΏۃubN
        target = hiliteItems( i );

        % ubN̂VXeJ
        parent_system = get_param( target, 'Parent' );
        open_system( parent_system );

        % _ł
        for x = 1:4
            hilite_system( target );
            pause( 0.3 );
            hilite_system( target, 'none' );
            pause( 0.3 );
        end
    end
end
